### 8.200 `RANDOM_NUMBER` — Pseudo-random number

Description:
  Returns a single pseudorandom number or an array of pseudorandom numbers from the uniform distribution over the range 0 \leq x < 1.

  The runtime-library implements George Marsaglia's KISS (Keep It Simple Stupid) random number generator (RNG). This RNG combines:

  1. The congruential generator x(n) = 69069 \cdot x(n-1) + 1327217885 with a period of 2^32,
  2. A 3-shift shift-register generator with a period of 2^32 - 1,
  3. Two 16-bit multiply-with-carry generators with a period of 597273182964842497 > 2^59.
  The overall period exceeds 2^123.

  Please note, this RNG is thread safe if used within OpenMP directives, i.e., its state will be consistent while called from multiple threads. However, the KISS generator does not create random numbers in parallel from multiple sources, but in sequence from a single source. If an OpenMP-enabled application heavily relies on random numbers, one should consider employing a dedicated parallel random number generator instead.

Standard:
  Fortran 95 and later
Class:
  Subroutine
Syntax:
  `RANDOM_NUMBER(HARVEST)`
Arguments:

  HARVEST | Shall be a scalar or an array of type `REAL`.

Example:

                program test_random_number
                  REAL :: r(5,5)
                  CALL init_random_seed()         ! see example of RANDOM_SEED
                  CALL RANDOM_NUMBER(r)
                end program

See also:
  RANDOM_SEED